/*
 * Nasty compatibility functions that don't need to go into the
 * mainline kernel.
 */

#if (LINUX_VERSION_CODE < 131343)  /* 2.1.15 -- XX get correct version */
#define __init
#endif

#if (LINUX_VERSION_CODE < 0x20000)
typedef dev_t kdev_t;
#endif

#if (LINUX_VERSION_CODE < 0x02017E)
static signed long schedule_timeout(signed long timeout)
{
	unsigned long expire;

	expire = timeout + jiffies;

	current->timeout = jiffies + timeout;
	schedule();

	timeout = expire - jiffies;
	return timeout < 0 ? 0 : timeout;
}
#endif

#ifndef time_after
#define time_after(a,b)		((long)(b) - (long)(a) < 0)
#endif

#if (LINUX_VERSION_CODE < 0x020100)
static inline int irq_cannonicalize(int irq)
{
	return ((irq == 2) ? 9 : irq);
}
#endif

#if (LINUX_VERSION_CODE < 131336)
static int copy_from_user(void *to, const void *from_user, unsigned long len)
{
	int	error;

	error = verify_area(VERIFY_READ, from_user, len);
	if (error)
		return len;
	memcpy_fromfs(to, from_user, len);
	return 0;
}

static int copy_to_user(void *to_user, const void *from, unsigned long len)
{
	int	error;
	
	error = verify_area(VERIFY_WRITE, to_user, len);
	if (error)
		return len;
	memcpy_tofs(to_user, from, len);
	return 0;
}

static inline int signal_pending(struct task_struct *p)
{
	return (p->signal & (~p->blocked != 0));
}

#endif

#if (LINUX_VERSION_CODE < 131394) /* 2.1.66 */
#define test_and_clear_bit(x,y)		clear_bit(x,y)

static inline void remove_bh(int nr)
{
	bh_base[nr] = NULL;
	bh_mask &= ~(1 << nr);
}
#endif

#ifndef set_current_state
#define set_current_state(state_value)			\
	do { current->state = state_value; } while (0)
#endif

#ifndef DECLARE_WAITQUEUE
#define DECLARE_WAITQUEUE(wait, current) \
	struct wait_queue wait = { current, NULL }
#define init_waitqueue_head(head)	init_waitqueue(head)
#endif

#ifndef CAP_SYS_ADMIN
#define capable(x)	(suser())
#endif
	
#if (LINUX_VERSION_CODE < 0x020317) /* 2.3.23 */
#define get_zeroed_page(x)	get_free_page(x)
#endif

/* Deal with the interface change in 2.3.23 */
#if defined(CONFIG_SERIAL_CONSOLE) && (LINUX_VERSION_CODE < 0x020317)
void __init serial_console_init_real(void);
long __init serial_console_init(long kmem_start, long kmem_end)
{
	serial_console_init_real();
	return kmem_start;
}

#define serial_console_init	serial_console_init_real
#endif
	

